=== tools/CMakeLists.txt ===
add_executable(xorwow_precomputed_generator xorwow_precomputed_generator.cpp)
add_executable(sobol32_direction_vector_generator sobol32_direction_vector_generator.cpp)
add_executable(sobol64_direction_vector_generator sobol64_direction_vector_generator.cpp)
add_executable(mrg32k3a_precomputed_generator mrg32k3a_precomputed_generator.cpp)
