=== debian/changelog ===
rocrand (5.3.3-6) unstable; urgency=medium

  * d/rules: explicitly disable lto
  * d/rules: drop unnecessary CFLAGS filtering
  * d/t/control: limit autopkgtest architectures

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 04 Jul 2023 23:57:48 -0600

rocrand (5.3.3-5) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 14 Jun 2023 13:15:07 -0600

rocrand (5.3.3-5~exp1) experimental; urgency=medium

  * Reintroduce the changes we temporarily reverted for bookworm, these being:
    - Add myself to Uploaders
    - Fix Maintainer name
    - Add packages librocrand1-tests, libhiprand1-tests providing autopkgtests
      In previous versions, these were called -test (singular). However, those
      packages never left unstable, and were reverted for bookworm
    - Reduce arch to amd64, arm64, ppc64el
    - d/rules: enable hardening flags
    - d/rules: enable gfx1010 and gfx1011
  * libhiprand-dev depends on librocrand-dev
    This seems to have been overlooked when fixing #1035787

 -- Christian Kastner <ckk@debian.org>  Sun, 11 Jun 2023 13:50:43 +0200

rocrand (5.3.3-4) unstable; urgency=medium

  * Temporarily revert fixes unfit for bookworm.
    Specifically, revert all changes from after 5.3.3-1.

  * Add missing dependency on libamdhip64-dev (Closes: #1035784, #1035787)

 -- Christian Kastner <ckk@debian.org>  Sun, 28 May 2023 18:25:03 +0200

rocrand (5.3.3-3) unstable; urgency=medium

  * Upload to unstable.

 -- Christian Kastner <ckk@debian.org>  Sun, 16 Apr 2023 22:45:08 +0200

rocrand (5.3.3-3~exp1) experimental; urgency=medium

  * Add myself to Uploaders
  * Fix Maintainer name
  * Add packages librocrand1-test, libhiprand1-test providing autopkgtests

 -- Christian Kastner <ckk@debian.org>  Thu, 13 Apr 2023 23:41:30 +0200

rocrand (5.3.3-2) unstable; urgency=medium

  [ Christian Kastner ]
  * Reduce arch to amd64, arm64, ppc64el

  [ Cordell Bloor ]
  * d/rules: enable hardening flags
  * d/rules: enable gfx1010 and gfx1011

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 06 Mar 2023 00:41:11 -0700

rocrand (5.3.3-1) unstable; urgency=medium

  * d/{watch,gbp.conf}: recombine with hiprand as MUT
  * New upstream version 5.3.3
  * d/{control,rules,*.install}: update install dirs
    Closes: #1028957
  * d/control: update standards version
  * d/lib{roc,hip}rand-dev.examples: remove examples
  * d/not-installed: ignore test binaries
  * d/librocrand1.symbols.amd64: add new symbols
  * add d/patches/0001-hide-kernel-symbols.patch
  * d/librocrand1.symbols.amd64: update symbols
  * d/copyright: update copyright file
  * d/rules: fix debug symbols

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 07 Feb 2023 00:06:45 -0700

rocrand (5.0.0-2) unstable; urgency=medium

  [ Étienne Mollier ]
  * d/rules: append reminder for fhs compliance.

  [ Cordell Bloor ]
  * d/control: add missing dependency on rocm-cmake
  * d/rules: remove unnecessary options and variables

  [ Étienne Mollier ]
  * d/control: stick to ROCm short form in packages descriptions.

 -- Étienne Mollier <emollier@debian.org>  Wed, 16 Nov 2022 21:37:21 +0100

rocrand (5.0.0-1) unstable; urgency=medium

  [ Maxime Chambonnet ]
  * Initial release. (Closes: #1019227)

 -- Étienne Mollier <emollier@debian.org>  Wed, 14 Sep 2022 22:05:49 +0200
