=== debian/control ===
Source: rocrand
Section: devel
Homepage: https://github.com/rocmsoftwareplatform/rocrand
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rocm-team/rocrand.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocrand
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Étienne Mollier <emollier@debian.org>,
           Cordell Bloor <cgmb@slerp.xyz>,
           Christian Kastner <ckk@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               hipcc,
               git,
               libamd-comgr-dev,
               libamdhip64-dev,
               libhsa-runtime-dev,
               patchelf,
               rocminfo,
               rocm-cmake (>= 5.3.0),
               libgtest-dev <!nocheck>
Rules-Requires-Root: no

Package: librocrand1
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: generate pseudo- and quasi-random numbers - library
 The rocRAND project provides functions that generate pseudo-random and
 quasi-random numbers.
 .
 The rocRAND library is implemented in the HIP programming language and
 optimised for AMD's latest discrete GPUs. It is designed to run on top of
 AMD's ROCm runtime, but it also works on CUDA enabled GPUs.
 .
 This package provides the AMD ROCm rocRAND library.

Package: librocrand-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocrand1 (= ${binary:Version}),
         libamdhip64-dev,
         ${misc:Depends},
         ${shlibs:Depends},
Description: generate pseudo- and quasi-random numbers - headers
 The rocRAND project provides functions that generate pseudo-random and
 quasi-random numbers.
 .
 The rocRAND library is implemented in the HIP programming language and
 optimised for AMD's latest discrete GPUs. It is designed to run on top of
 AMD's ROCm runtime, but it also works on CUDA enabled GPUs.
 .
 This package provides AMD ROCm rocRAND development headers.

Package: librocrand1-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocrand1 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Description: generate pseudo- and quasi-random numbers - test binaries
 The rocRAND project provides functions that generate pseudo-random and
 quasi-random numbers.
 .
 The rocRAND library is implemented in the HIP programming language and
 optimised for AMD's latest discrete GPUs. It is designed to run on top of
 AMD's ROCm runtime, but it also works on CUDA enabled GPUs.
 .
 This package provides AMD ROCm rocRAND test binaries. These binaries are
 only used to check whether rocRAND works correctly on a given GPU, so
 generally speaking, users probably don't need this package.

Package: libhiprand1
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: wrapper library to port from cuRAND applications to HIP - library
 The rocRAND project includes a wrapper library called hipRAND which allows
 user to easily port CUDA applications that use cuRAND library to the HIP
 layer. In ROCm environment hipRAND uses rocRAND, however in CUDA environment
 cuRAND is used instead.
 .
 This package provides AMD ROCm hipRAND library.

Package: libhiprand-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libhiprand1 (= ${binary:Version}),
         libamdhip64-dev,
         librocrand-dev,
         ${misc:Depends},
         ${shlibs:Depends},
Description: wrapper library to port from cuRAND applications to HIP - headers
 The rocRAND project includes a wrapper library called hipRAND which allows
 user to easily port CUDA applications that use cuRAND library to the HIP
 layer. In ROCm environment hipRAND uses rocRAND, however in CUDA environment
 cuRAND is used instead.
 .
 This package provides AMD ROCm hipRAND development headers.

Package: libhiprand1-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libhiprand1 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Description: wrapper library to port from cuRAND applications to HIP - tests
 The rocRAND project includes a wrapper library called hipRAND which allows
 user to easily port CUDA applications that use cuRAND library to the HIP
 layer. In ROCm environment hipRAND uses rocRAND, however in CUDA environment
 cuRAND is used instead.
 .
 This package provides AMD ROCm hipRAND test binaries. These binaries are
 only used to check whether hipRAND works correctly on a given GPU, so
 generally speaking, users probably don't need this package.
