=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries librocrand1-tests
Depends: librocrand1-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el

Test-Command: /bin/sh debian/tests/upstream-binaries libhiprand1-tests
Depends: libhiprand1-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
